Unit MLC6R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTMLCP_p, MLC6R0_p, MLC6R1_p, MLC6R2_p, MLC6R5_p, UTMLCJ_p,
UTMN05_p;

procedure MLC6R(var A :Array of Integer; var B :Array of Integer;
                var C :Array of Integer; var IERR :Integer;
                M :Integer; var MIN :Integer; N :Integer;
                var P :Array of Integer; Q :Integer;
                var UP :Array of Real; var X :Array of Integer);

implementation

procedure MLC6R(var A :Array of Integer; var B :Array of Integer;
                var C :Array of Integer; var IERR :Integer;
                M :Integer; var MIN :Integer; N :Integer;
                var P :Array of Integer; Q :Integer;
                var UP :Array of Real; var X :Array of Integer);
var
DEL,DEL1,DEL2,I,I1,I2,I21,I3,I31,L,N1,N2,S :Integer;
T,T0,TMAX :Real;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120,_130,_140,_150,
_160;
begin
{    PEEHE AA EOCEHHOO POPAMMPOBAH C YEB- }
{    M EPEMEHHM METOOM BEKTOPA CAA. }
{    MATPA YCOB XPAHTC B YAKOBAHHOM BE. }
{    A- AAHHA MATPA OPAHEH M*N, B- CTOE PABX }
{    ACTE H M, C- BEKTOP KOEHTOB HEHO OPM, }
{    H N, Q - CO PABEHCTB; }
{    X - BEKTOP EPEMEHHX H N, HA BXOE COEPT KOMOHEHT }
{        PEEH, }
{    MIN - HA BXOE COEPT OTMAHOE HAEHE HEHO }
{          OPM (EC A HAEHA OYCTMA TOKA) }
{    UP - BEKTOP YPABX APAMETPOB H 2, BEECTBEEHH: }
{         UP(1) HA BXOE COEPT AAHHOE BPEM CETA B CEK, }
{              HA BXOE - BPEM,ATPAEHHOE EHTPAHM PO- }
{                          ECCOPOM HA PEEHE AA, }
{         UP(2) - PHAK EAT PEYTATOB: }
{                UP(2)=O. -EAT HE YET, }
{                UP(2)=1. -YET HAEATAHA PHA OCTAHOBA }
{         UP MOET AABATC O YMOAH. }
{   IERR YKABAET PHY BXOA  OPOPAMM: }
{        IERR=0 -HAEH OKAH MHMYM B OKPECTHOCT }
{                OYEHHO TOK PAYCA 3, }
{        IERR=5 - CTEKO AAHHOE BPEM, }
{        IERR=65 - HE HAEHA OYCTMA TOKA B OKA- }
{                   HO OACT. }
{   P-  PAO BEKTOP H M. }
TMAX := UP[0];
{  -------AOMHM HAAHOE BPEM: }
UTMN05(T0);
{ ---------OCK OYCTMO TOK: }
MLC6R0(A,B,C,IERR,M,N,P,Q,X);
{          PRINT 179,IERR,X }
{ 179      FORMAT(2X,'IERR=',I4,'X=',4I4) }
if ( IERR =  0 ) 
 then goto _10;
if ( UP[1] =  1 ) 
 then UTMLCP(IERR,1);
goto _160;
{  ---------------EM YY TOKY B OKPECTHOCT PAYCA 1 }
_10:
{           PRINT 178,X }
{ 178       FORMAT(2X,'YA TOKA  ',20I4) }
{                 PRINT 199 }
{ 199          FORMAT(2X,'EM YY TOKY B OKPECTHOCT R=1') }
{  ---------POBEPKA,HE CTEKO  BPEM ---- }
UTMN05(T);
T := T - T0;
if ( T <  TMAX ) 
 then goto _20;
IERR := 5;
goto _140;
_20:
for I1:=1 to N do
 begin
  MLC6R5(DEL,X,C,I1);
  if ( DEL >=  0 ) 
   then goto _40;
{  -------------YBAHE ECT, POBEPM OPAHEH: }
  X[I1-1] := 1 - X[I1-1];
  MLC6R1(A,B,C,M,N,P,X);
  MLC6R2(M,P,Q,S);
  if ( S >  0 ) 
   then goto _30;
{  -----------------OYEHA YA TOKA }
  goto _10;
_30:
  X[I1-1] := 1 - X[I1-1];
  goto _40;
_40:
 end;
{  ---------POBEPKA,HE CTEKO  BPEM ---- }
UTMN05(T);
T := T - T0;
if ( T <  TMAX ) 
 then goto _50;
IERR := 5;
goto _140;
_50:
{  POOM OCK YE TOK B OKPECTHOCT PAYCA 2 }
{          PRINT 197 }
{ 197    FORMAT(2X,'EM YY TOKY B OKPECTHOCT PAYCA 2') }
N1 := N - 1;
for I1:=1 to N1 do
 begin
  I21 := I1 + 1;
  MLC6R5(DEL1,X,C,I1);
  X[I1-1] := 1 - X[I1-1];
  for I2:=I21 to N do
   begin
{         PRINT 333,I1,I2,X }
{ 333     FORMAT(2X,'I1=',I3,'I2=',I3,'X=',10I3) }
    MLC6R5(DEL,X,C,I2);
{            PRINT 334,DEL1,DEL }
{ 334       FORMAT(2X,'DEL1=',I3,'DEL=',I3) }
    DEL := DEL + DEL1;
    if ( DEL >=  0 ) 
     then goto _70;
{   ----------- YBAHE ECT,POBEPM OPAHEH: }
    X[I2-1] := 1 - X[I2-1];
{             PRINT 335,X }
{ 335         FORMAT(2X,'X=',10I4) }
    MLC6R1(A,B,C,M,N,P,X);
{          PRINT 218,P }
    MLC6R2(M,P,Q,S);
{          PRINT 216,S }
    if ( S >  0 ) 
     then goto _60;
{   -----------------OYEHA YA TOKA }
    goto _10;
_60:
    X[I2-1] := 1 - X[I2-1];
_70:
   end;
  X[I1-1] := 1 - X[I1-1];
_80:
 end;
{  ----POOAEM OCK YE TOK B OKPECTHOCT PAYCA 3 }
{        PRINT 196 }
{ 196  FORMAT(2X,'EM YY TOKY B OKPECTHOCT PAYCA 3') }
N2 := N - 2;
for I1:=1 to N2 do
 begin
  I21 := I1 + 1;
{  ---------POBEPKA,HE CTEKO  BPEM ---- }
  UTMN05(T);
  T := T - T0;
  if ( T <  TMAX ) 
   then goto _90;
  IERR := 5;
  goto _140;
_90:
  MLC6R5(DEL1,X,C,I1);
{  ------- AKCPYEM KOMOHEHTY X(I1): }
  X[I1-1] := 1 - X[I1-1];
  for I2:=I21 to N1 do
   begin
    MLC6R5(DEL2,X,C,I2);
    DEL2 := DEL1 + DEL2;
{  -------AKCPYEM KOMOHEHTY X(I2): }
    X[I2-1] := 1 - X[I2-1];
    I31 := I2 + 1;
    for I3:=I31 to N do
     begin
{               PRINT 213,I3,X,DEL2 }
{ 213       FORMAT(2X,'I3=',I4,'X=',4I4,'DEL2=',I4) }
      MLC6R5(DEL,X,C,I3);
      DEL := DEL + DEL2;
      if ( DEL >=  0 ) 
       then goto _110;
{  ------------------YBAHE ECT,POBEPKA OPAHEH }
      X[I3-1] := 1 - X[I3-1];
      MLC6R1(A,B,C,M,N,P,X);
{             PRINT 218,P }
{  218        FORMAT(2X,'P=',3I4) }
      MLC6R2(M,P,Q,S);
{       PRINT 216,S }
{ 216   FORMAT(2X,'S=',I4) }
      if ( S >  0 ) 
       then goto _100;
{  ------------------OYEHA YA TOKA: }
      goto _10;
_100:
      X[I3-1] := 1 - X[I3-1];
_110:
     end;
{  -------------BOCCTAHOBM KOMOHEHTY I2: }
    X[I2-1] := 1 - X[I2-1];
_120:
   end;
  X[I1-1] := 1 - X[I1-1];
_130:
 end;
_140:
MIN := 0;
for I:=1 to N do
 begin
  L := C[I-1];
  UTMLCJ(L,I1);
  MIN := MIN + X[I-1]*L;
_150:
 end;
if ( UP[1] <>  1.0 ) 
 then goto _160;
UTMLCP(IERR,1);
_160:
{     BPEM,ATPAEHHOE HA PEEHE AA: }
UTMN05(T);
T := T - T0;
UP[0] := T;
end;

end.
